<template>
  <div>
    <div v-if="routes == null">
      <md-empty-state
        md-icon="check"
        md-label="Channel Validator"
        :md-description="statMessage"
      >
      </md-empty-state>
    </div>
    <div v-else id="main-container">
      <md-toolbar class="main-toolbar">
        <h1 class="md-title">{{ $t('mypage') }}</h1>
        <div class="md-toolbar-section-start">
          {{ api.app.app_uuid }}・{{ api.app.app_name }}
        </div>
        <div class="md-toolbar-section-end">
          <span>
            {{ lastUpdatedAt | last_updated }}-{{
              api.app.hash_code.substring(0, 4)
            }}
            <md-tooltip md-direction="bottom">
              {{ $t('updated_at') }}<br />
              {{ lastUpdatedAt }}(JST)
            </md-tooltip>
          </span>
        </div>
      </md-toolbar>

      <div class="md-layout">
        <div class="md-layout-item map-layout">
          <md-card>
            <md-card-header>
              <div class="md-title">
                {{ $t('channel') }}
              </div>
            </md-card-header>
            <md-card-content>
              <div class="md-layout">
                <div class="md-layout-item tb-text-center">
                  <h3>{{ numberOfCategoris }}</h3>
                  {{ $t('categories') }}
                </div>
                <div class="md-layout-item tb-text-center">
                  <h3>{{ numberOfScenarios }}</h3>
                  {{ $t('scenarios') }}
                </div>
                <div class="md-layout-item tb-text-center">
                  <h3>{{ numberOfItems }}</h3>
                  {{ $t('slots') }}
                </div>

                <div class="md-layout-item tb-text-center">
                  <h3>{{ numberOfVideos }}</h3>
                  {{ $t('videos') }}
                </div>
                <div class="md-layout-item tb-text-center">
                  <h3>
                    {{
                      (total4kVideoSize + total2kVideoSize)
                        | number_to_human_size
                    }}
                  </h3>
                  {{ $t('size') }}
                  <md-tooltip md-direction="bottom">
                    4K: {{ total4kVideoSize | number_to_human_size }}<br />
                    2K: {{ total2kVideoSize | number_to_human_size }}
                  </md-tooltip>
                </div>
                <div class="md-layout-item tb-text-center">
                  <h3 class="text-danger" v-if="numberOfErrors > 0">
                    {{ numberOfErrors }}
                  </h3>
                  <h3 v-else>0</h3>
                  {{ $t('not_playable') }}
                  <md-tooltip
                    md-direction="bottom"
                    v-html="$t('not_playable_warning')"
                  >
                  </md-tooltip>
                </div>
              </div>

              <div class="md-layout dashboard-layout mt-4">
                <div class="md-layout-item">
                  <md-button
                    class="md-simple"
                    v-on:click="changeChannelStructure(-1)"
                  >
                    <img
                      src="../../assets/images/all_categories_icon.png"
                      decoding="async"
                    />
                  </md-button>
                  <md-button
                    class="md-simple"
                    v-on:click="changeChannelStructure(0)"
                    v-if="numberOfCategoris >= 2"
                  >
                    <img
                      src="../../assets/images/new_contents_icon.png"
                      decoding="async"
                    />
                  </md-button>
                  <md-button
                    class="md-simple"
                    v-for="category in api.categories"
                    v-bind:key="category.category_id"
                    v-on:click="changeChannelStructure(category.category_id)"
                  >
                    <img
                      :src="category.circle_logo_image_url"
                      decoding="async"
                    />
                  </md-button>
                </div>
              </div>

              <md-table>
                <md-table-row>
                  <md-table-head>{{ $t('categories') }}</md-table-head>
                  <md-table-head>{{ $t('scenarios') }}</md-table-head>
                  <md-table-head>{{ $t('slots') }}</md-table-head>
                  <md-table-head
                    >{{ $t('buttons') }}・{{ $t('quizzes') }}</md-table-head
                  >
                  <md-table-head>{{ $t('videos') }}</md-table-head>
                  <md-table-head>{{ $t('published_at') }}</md-table-head>
                </md-table-row>

                <md-table-row
                  v-for="(channel, index) in channelStructure"
                  v-bind:key="index"
                >
                  <md-table-cell>
                    <p
                      v-if="
                        channel.category_id != 0 && channel.scenario_name != ''
                      "
                    >
                      <img
                        :src="channel.category_icon_image_url"
                        decoding="async"
                      />
                      Category:{{ channel.category_id }}・{{
                        channel.category_name
                      }}
                    </p>
                    <p
                      v-if="
                        channel.category_id == 0 && channel.scenario_name != ''
                      "
                    >
                      <img
                        src="../../assets/images/new_contents_icon.png"
                        decoding="async"
                      />
                      Category:{{ channel.category_id }}・NEW
                    </p>
                  </md-table-cell>
                  <md-table-cell>
                    <p v-if="channel.scenario_id != ''">
                      <img
                        :src="channel.scenario_icon_image_url"
                        decoding="async"
                      />
                      Scenario:{{ channel.scenario_id }}・{{
                        channel.scenario_name
                      }}
                    </p>
                  </md-table-cell>
                  <md-table-cell>
                    <p>
                      <img
                        :src="channel.item_icon_image_url"
                        decoding="async"
                      />
                      Item:{{ channel.item_id }}・{{ channel.item_name }}
                    </p>
                  </md-table-cell>
                  <md-table-cell>
                    <p>{{ $t('buttons') }}: {{ channel.number_of_buttons }}</p>
                    <p>
                      {{ $t('quizzes') }}: {{ channel.number_of_quizzes }}
                      <md-avatar v-if="channel.is_total_score_correct == false">
                        <md-icon>warning</md-icon>
                        <md-tooltip
                          md-direction="bottom"
                          v-html="$t('total_score_warning')"
                        >
                        </md-tooltip>
                      </md-avatar>
                    </p>
                  </md-table-cell>
                  <md-table-cell>
                    <p
                      v-on:click="changeVideoUrl(channel.video_url)"
                      style="cursor: pointer"
                    >
                      Video:{{ channel.video_name }} (
                      {{ channel.video_4k_size | number_to_human_size }} /
                      {{ channel.video_2k_size | number_to_human_size }})
                    </p>
                  </md-table-cell>
                  <md-table-cell>
                    <p>{{ channel.scenario_published_at | moment }}</p>
                  </md-table-cell>
                </md-table-row>
              </md-table>
            </md-card-content>
            <md-card-actions> </md-card-actions>
          </md-card>
        </div>
      </div>

      <div class="md-layout">
        <div class="md-layout-item">
          <md-card>
            <md-card-header>
              <div class="md-title">{{ $t('routes') }}</div>
            </md-card-header>
            <md-card-content>
              <md-table>
                <md-table-row>
                  <md-table-head>No</md-table-head>
                  <md-table-head>{{ $t('slots') }}</md-table-head>
                  <md-table-head>{{ $t('route') }}</md-table-head>
                  <md-table-head>{{
                    $t('number_of_transitions')
                  }}</md-table-head>
                </md-table-row>

                <md-table-row
                  v-for="(route, index) in routes"
                  v-bind:key="index"
                >
                  <md-table-cell>{{ index + 1 }}</md-table-cell>
                  <md-table-cell>
                    {{ route.route }}
                  </md-table-cell>
                  <md-table-cell>
                    <ol>
                      <li v-for="path in route.paths" v-bind:key="path">
                        {{ path }}
                      </li>
                    </ol>
                  </md-table-cell>
                  <md-table-cell>
                    <b v-if="route.paths.length > 0" class="text-success">{{
                      route.paths.length
                    }}</b>
                    <b v-else class="text-danger">{{ $t('not_playable') }}</b>
                  </md-table-cell>
                </md-table-row>
              </md-table>
            </md-card-content>
          </md-card>
        </div>
      </div>

      <div class="md-layout">
        <div class="md-layout-item map-layout">
          <md-card>
            <md-card-header>
              <div class="md-title">{{ $t('graph') }}</div>
              <p class="tb-left">
                {{ numberOfNodes }} nodes, {{ numberOfEdegs }} edges
              </p>
              <md-button class="tb-right" @click="exportGraphPdf">
                <md-icon>arrow_downward</md-icon> PDF
              </md-button>
            </md-card-header>
            <md-card-content>
              <div id="graph"></div>
            </md-card-content>
            <md-card-actions> </md-card-actions>
          </md-card>
        </div>
      </div>

      <md-dialog :md-active.sync="showVideoDialog">
        <video :src="videoUrl" controls></video>
      </md-dialog>
    </div>
  </div>
</template>

<script>
import { mapActions } from 'vuex';
import Viz from 'viz.js';
import { Module, render } from 'viz.js/full.render.js';
import svgPanZoom from 'svg-pan-zoom';
let viz = new Viz({ Module, render });

export default {
  data() {
    return {
      statMessage: '読み込み中',
      routes: null,
      numberOfNodes: 0,
      numberOfEdegs: 0,
      api: null,
      dot: null,
      exportGraphPdfUrl: '',
      numberOfCategoris: 0,
      numberOfScenarios: 0,
      numberOfItems: 0,
      numberOfVideos: 0,
      numberOfErrors: 0,
      total4kVideoSize: 0,
      total2kVideoSize: 0,
      lastUpdatedAt: '',
      channelStructure: [],
      isFirstRunOfChannelStructure: true,
      videoUrl: null,
      showVideoDialog: false,
      allContents: [],
    };
  },
  watch: {},
  mounted() {
    this.fetchChannelValidator(this.$route.query)
      .then((e) => {
        this.exportGraphPdfUrl = e.data.export_graph_pdf_url;
        this.routes = e.data.routes;
        // コストが低い順にソートする
        this.routes.sort(function (a, b) {
          if (a.paths.length < b.paths.length) return -1;
          if (a.paths.length > b.paths.length) return 1;
          return 0;
        });

        this.numberOfNodes = e.data.number_of_nodes;
        this.numberOfEdegs = e.data.number_of_edges;
        this.api = e.data.api;
        this.dot = e.data.dot;

        // アイテムへのルートが存在しない数
        this.numberOfErrors = this.routes.filter(
          (e) => e.paths.length == 0
        ).length;
        this.createChannelStructure();
        this.changeChannelStructure(-1);

        let date = new Date(this.api.app.timestamp * 1000);
        this.lastUpdatedAt =
          date.toLocaleDateString('ja-JP') +
          ' ' +
          date.toLocaleTimeString('ja-JP');

        viz
          .renderSVGElement(this.dot)
          .then((element) => {
            element.setAttribute('id', 'graph-svg');
            document.getElementById('graph').append(element);
            var zoomOptions = {
              minZoom: 0.1,
              maxZoom: 10,
              controlIconsEnabled: false,
            };
            svgPanZoom('#graph-svg', zoomOptions);
          })
          .catch((e) => {
            // グラフの作成に失敗
          });
      })
      .catch((e) => {
        this.statMessage =
          'チャンネルまたはカテゴリやシナリオが1つもありません。';
      });
  },
  methods: {
    ...mapActions(['fetchChannelValidator']),
    exportGraphPdf() {
      window.open(this.exportGraphPdfUrl);
    },
    changeVideoUrl(url) {
      this.videoUrl = url;
      this.showVideoDialog = true;
    },
    createChannelStructure() {
      // チャンネルの表を作成する
      var categoryId = '';
      var scenarioId = '';
      var itemId = '';
      var videoId = '';
      var categoryName = '';
      var scenarioName = '';
      var itemName = '';
      var videoName = '';
      var categoryIconImageUrl = '';
      var scenarioIconImageUrl = '';
      var itemIconImageUrl = '';
      var videoUrl = '';
      var scenarioPublishedAt = '';
      var allScenarios = [];
      // ビデオの重複確認用の配列
      var duplicateVideoIds = [];

      const isTotalScoreCorrect = function (item) {
        // 合計スコアが100でないときfalseを返します

        var isCorrect = true;

        item.quizzes.forEach((quiz) => {
          // 合計スコアを求める
          var score = 0;
          var totalScore = quiz.markers.reduce(
            (accumulator, currentValue) => accumulator + currentValue.score,
            score
          );

          if (totalScore != 100) {
            isCorrect = false;
          }
        });

        return isCorrect;
      };

      this.api.categories.forEach((category) => {
        this.numberOfCategoris += 1;

        categoryId = category.category_id;
        categoryName = category.category_name;
        categoryIconImageUrl = category.circle_logo_image_url;

        category.scenarios.forEach((scenario) => {
          // 新着シナリオを決定するためシナリオを格納
          allScenarios.push(scenario);

          this.numberOfScenarios += 1;

          scenarioId = scenario.scenario_id;
          scenarioName = scenario.scenario_title;
          scenarioIconImageUrl = scenario.scenario_thumbnail_url;
          scenarioPublishedAt = scenario.published_at;

          scenario.items.forEach((item) => {
            this.numberOfItems += 1;

            itemId = item.item_id;
            itemName = item.content_title;
            itemIconImageUrl = item.content_thumbnail_url;

            videoId = item.content_id;
            videoName = item.content_id;
            videoUrl = item.content_download_video_url;

            if (duplicateVideoIds.indexOf(videoId) == -1) {
              // ビデオの重複確認
              duplicateVideoIds.push(videoId);
              this.numberOfVideos += 1;
              this.total4kVideoSize += item.content_file_size;
              this.total2kVideoSize += item.content_2k_file_size;
            }

            this.allContents.push({
              category_id: categoryId,
              category_name: categoryName,
              category_icon_image_url: categoryIconImageUrl,
              scenario_id: scenarioId,
              scenario_name: scenarioName,
              scenario_icon_image_url: scenarioIconImageUrl,
              scenario_published_at: scenarioPublishedAt,
              item_id: itemId,
              item_name: itemName,
              item_icon_image_url: itemIconImageUrl,
              video_id: videoId,
              video_name: videoName,
              video_url: videoUrl,
              video_4k_size: item.content_file_size,
              video_2k_size: item.content_2k_file_size,
              number_of_buttons: item.buttons.length,
              number_of_quizzes: item.quizzes.length,
              is_total_score_correct: isTotalScoreCorrect(item),
            });

            categoryName = '';
            scenarioId = '';
            scenarioName = '';
            scenarioPublishedAt = '';
          });
        });
      });

      // 新着シナリオを求めるために公開日時でソートする
      var newScenarios = allScenarios.sort((a, b) => {
        if (a.published_at > b.published_at) return -1;
        if (a.published_at < b.published_at) return 1;
        return 0;
      });

      // 新着シナリオは最大16件
      newScenarios = newScenarios.slice(0, 16);
      categoryId = 0;
      categoryName = '';

      newScenarios.forEach((scenario) => {
        scenarioId = scenario.scenario_id;
        scenarioName = scenario.scenario_title;
        scenarioIconImageUrl = scenario.scenario_thumbnail_url;
        scenarioPublishedAt = scenario.published_at;

        scenario.items.forEach((item) => {
          itemId = item.item_id;
          itemName = item.content_title;
          itemIconImageUrl = item.content_thumbnail_url;

          videoId = item.content_id;
          videoName = item.content_id;
          videoUrl = item.content_download_video_url;

          this.allContents.push({
            category_id: categoryId,
            category_name: categoryName,
            category_icon_image_url: null,
            scenario_id: scenarioId,
            scenario_name: scenarioName,
            scenario_icon_image_url: scenarioIconImageUrl,
            scenario_published_at: scenarioPublishedAt,
            item_id: itemId,
            item_name: itemName,
            item_icon_image_url: itemIconImageUrl,
            video_id: videoId,
            video_name: videoName,
            video_url: videoUrl,
            video_4k_size: item.content_file_size,
            video_2k_size: item.content_2k_file_size,
            number_of_buttons: item.buttons.length,
            number_of_quizzes: item.quizzes.length,
            is_total_score_correct: isTotalScoreCorrect(item),
          });

          scenarioId = '';
          scenarioName = '';
          scenarioPublishedAt = '';
        });
      });
    },
    changeChannelStructure(category_id) {
      if (category_id == -1) {
        this.channelStructure = this.allContents.filter(
          (e) => e.category_id != 0
        );
      } else {
        this.channelStructure = this.allContents.filter(
          (e) => e.category_id == category_id
        );
      }
    },
  },
};
</script>

<style>
html,
body {
  margin: 0;
  padding: 0;
}

#main-container {
  width: 100%;
}

#graph {
  width: 100%;
  height: 400px;
  margin-top: 20px;
}

#graph-svg {
  width: 100%;
  height: 100%;
}

.dashboard-layout {
  border-top: 2px solid #f5f5f5;
  border-bottom: 2px solid #f5f5f5;
  padding: 0;
  margin: 0;
}

.map-layout img {
  width: 40px;
}

.main-toolbar {
  border-radius: 0px;
  background: #3b3b3b !important;
}

.main-toolbar .md-title {
  font-weight: bold;
}

.tb-text-center {
  text-align: center;
}
</style>
